<template>
	<mind-layout>
		<mind-form v-model="recurso" @submit="onSubmit">
			<template v-slot="{form}">
					<el-row  >
						<el-col  :lg="12">
							<el-form-item label="Nombre" prop="nombre">
								<el-input v-model="form.nombre"/>
							</el-form-item>
						</el-col>
						<el-col :lg="12">
							<el-form-item label="Nombre Alternativo">
								<el-input v-model="form.nombreAlternativo" />
							</el-form-item>
						</el-col>
					</el-row>
					<el-row  >
						<el-col  :lg="12">
							<el-form-item label="Tipo">
								<el-select v-model="form.tipo">
									<el-option value="Lugar">Lugar</el-option>
									<el-option value="Calle">Calle</el-option>
								</el-select>
							</el-form-item>
						</el-col>
						<el-col :lg="12">
							<el-form-item label="Localidad">
								<el-input v-model="form.localidad" />
							</el-form-item>
						</el-col>
					</el-row>
					<el-row  >
						<el-col  :lg="12">
							<el-form-item label="Uso Frecuente">
								<el-checkbox v-model="form.frecuente" />
							</el-form-item>
						</el-col>
					</el-row>

			</template>
		</mind-form>
	</mind-layout>
</template>
<script>
import store from '@/store/lugares'
import {Rest} from '@/../vendor/mind-core-web'

export default {
	async created(){
		this.api = new Rest({
			uri: `/api/viajes/agencias/${store.idAgencia}/lugares`, 
			state: store.data,
			key: 'id'
		})

		let id = this.$route.params.id
		if(id == 'new') {
			this.isNew = true
			this.recurso = {	}
		} else {
			this.recurso = await this.api.Fetch(id).catch((error)=>{
				this.$message({
					showClose: true,
					type: 'error',
					message: error
				});				
			})
		}
	},

	methods: {
		async onSubmit(data) {
			let result, msg ;
			if(this.isNew) {
				await this.api.Post(data)
				.then(()=>{
					result = 'success'
					msg = 'Lugar/Calle creado correctamente'
				})
				.catch((error)=> {
					result = 'error'
					msg = error
				})
			} else {
				await this.api.Patch(data)
				.then(()=>{
					result = 'success'
					msg = 'Lugar/Calle actualizado correctamente'
				})
				.catch((error)=> {
					result = 'error'
					msg = error
				})
			}
			this.$message({
				type: result,
				showClose: true,
				message: msg
			});
		}
	},
	data() {
		return {
			isNew: false,
			recurso: {},
			api: null
		}
	}
}
</script>